package javax.imageio.metadata;

import java.util.Locale;
import javax.imageio.ImageTypeSpecifier;

public interface IIOMetadataFormat
{
    public static final int CHILD_POLICY_EMPTY = 0;
    public static final int CHILD_POLICY_ALL = 1;
    public static final int CHILD_POLICY_SOME = 2;
    public static final int CHILD_POLICY_CHOICE = 3;
    public static final int CHILD_POLICY_SEQUENCE = 4;
    public static final int CHILD_POLICY_REPEAT = 5;
    public static final int CHILD_POLICY_MAX = 5;
    public static final int VALUE_NONE = 0;
    public static final int VALUE_ARBITRARY = 1;
    public static final int VALUE_RANGE = 2;
    public static final int VALUE_RANGE_MIN_INCLUSIVE_MASK = 4;
    public static final int VALUE_RANGE_MAX_INCLUSIVE_MASK = 8;
    public static final int VALUE_RANGE_MIN_INCLUSIVE = 6;
    public static final int VALUE_RANGE_MAX_INCLUSIVE = 10;
    public static final int VALUE_RANGE_MIN_MAX_INCLUSIVE = 14;
    public static final int VALUE_ENUMERATION = 16;
    public static final int VALUE_LIST = 32;
    public static final int DATATYPE_STRING = 0;
    public static final int DATATYPE_BOOLEAN = 1;
    public static final int DATATYPE_INTEGER = 2;
    public static final int DATATYPE_FLOAT = 3;
    public static final int DATATYPE_DOUBLE = 4;
    
    public abstract String getRootName();
    
    public abstract boolean canNodeAppear(String p0, ImageTypeSpecifier p1);
    
    public abstract int getElementMinChildren(String p0);
    
    public abstract int getElementMaxChildren(String p0);
    
    public abstract String getElementDescription(String p0, Locale p1);
    
    public abstract int getChildPolicy(String p0);
    
    public abstract String[] getChildNames(String p0);
    
    public abstract String[] getAttributeNames(String p0);
    
    public abstract int getAttributeValueType(String p0, String p1);
    
    public abstract int getAttributeDataType(String p0, String p1);
    
    public abstract boolean isAttributeRequired(String p0, String p1);
    
    public abstract String getAttributeDefaultValue(String p0, String p1);
    
    public abstract String[] getAttributeEnumerations(String p0, String p1);
    
    public abstract String getAttributeMinValue(String p0, String p1);
    
    public abstract String getAttributeMaxValue(String p0, String p1);
    
    public abstract int getAttributeListMinLength(String p0, String p1);
    
    public abstract int getAttributeListMaxLength(String p0, String p1);
    
    public abstract String getAttributeDescription(String p0, String p1, Locale p2);
    
    public abstract int getObjectValueType(String p0);
    
    public abstract Class<?> getObjectClass(String p0);
    
    public abstract Object getObjectDefaultValue(String p0);
    
    public abstract Object[] getObjectEnumerations(String p0);
    
    public abstract Comparable<?> getObjectMinValue(String p0);
    
    public abstract Comparable<?> getObjectMaxValue(String p0);
    
    public abstract int getObjectArrayMinLength(String p0);
    
    public abstract int getObjectArrayMaxLength(String p0);
}
